<script setup>
import { onBeforeMount, ref } from "vue";
import axios from "axios";
import CardContainer from "./components/CardContainer.vue";

const baseAPI = "https://pokeapi.co/api/v2/pokemon";
const baseID = [1, 4, 7];
const pokemons = ref([]);
let subPokemons = ref([]);

const pokemonData = async (ids) => {
  const responses = await Promise.all(
    ids.map((id) => axios.get(`${baseAPI}/${id}`))
  );
  const datas = responses.map((response) => response.data);
  return datas;
};

const subPoke = async (pokemon) => {
  const subPokemonsData = await pokemonData([pokemon.id + 1, pokemon.id + 2]);
  subPokemons.value = [subPokemonsData];
  console.log(subPokemons.value);
};

onBeforeMount(async () => {
  const datas = await pokemonData(baseID);
  pokemons.value.push(datas);
});

// onMounted(async () => {
//   for (let item in pokemonNameList) {
//     const { data } = await axios.get(`${baseAPI}/${pokemonNameList[item]}`);
//     pokemons.value.push(data);
//   }
// });
</script>

<template>
  <div class="container">
    <CardContainer :pokemons="pokemons" @subPokemonClick="subPoke($event)" />
    <template v-if="subPokemons">
      <CardContainer :pokemons="subPokemons" />
    </template>
  </div>
</template>

<style lang="scss">
body {
  margin: 0;
  padding: 0;
}
.container {
  display: flex;
  align-items: center;
  // justify-content: center;
  flex-direction: column;
  width: 70vw;
  height: 100vh;
  margin: 0px auto;

  &-main {
    display: flex;
    align-items: center;
    justify-content: center;
    gap: 20px;
  }
}
</style>
